package ink.wgink.login.base.service.count;

import java.util.List;
import java.util.Map;

/**
 * When you feel like quitting. Think about why you started
 * 当你想要放弃的时候，想想当初你为何开始
 *
 * @ClassName: ICountService
 * @Description: 统计
 * @Author: wanggeng
 * @Date: 2021/2/28 9:36 上午
 * @Version: 1.0
 */
public interface ICountService {

    String DAY_FORMATTER = "yyyy-MM-dd";

    /**
     * 统计新增用户数量统计（按周统计）
     *
     * @param params
     * @return
     */
    Map<String, Object> countNewUserByWeek(Map<String, Object> params);

    /**
     * 统计用户数量
     *
     * @param params
     * @return
     */
    Map<String, Object> countUser(Map<String, Object> params);

    /**
     * 系统登录量统计
     *
     * @param params
     * @return
     */
    Map<String, Object> countLogin(Map<String, Object> params);

    /**
     * 系统登录量统计（按展示天数）
     *
     * @param days
     * @return
     */
    Map<String, Object> countLoginForDays(Integer days);

    /**
     * 统计机构数量
     *
     * @return
     */
    Integer countDepartment();

    /**
     * 统计角色数量
     *
     * @return
     */
    Integer countRole();

    /**
     * 统计职位数量
     *
     * @return
     */
    Integer countPosition();

    /**
     * 统计用户类型比例
     *
     * @return
     */
    List<Map<String, Object>> countUserTypeProportion();

    /**
     * 统计用户状态比例
     *
     * @return
     */
    List<Map<String, Object>> countUserStateProportion();

}
